﻿<?php

defined ('_JEXEC') or die('Restricted access');


if (!class_exists ('vmPSPlugin')) {
	require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');
}

class plgVmPaymentRivhit extends vmPSPlugin {
	public static $_this = FALSE;
	const RIVHIT_DEFAULT_PAYMENT_CURRENCY = "USD";
	function __construct (& $subject, $config) {
		parent::__construct ($subject, $config);
		$varsToPush = $this->getVarsToPush ();
		$this->setConfigParameterable ($this->_configTableFieldName, $varsToPush);
		
		//NEXT STEP - ADD Report Table if not exist
		$this->tableFields = array_keys ($this->getTableSQLFields ());
		$this->_tablepkey = 'id';
		$this->_tableId = 'id';
	}
function plgVmDeclarePluginParamsPaymentVM3( &$data) {
		return $this->declarePluginParams('payment', $data);
	}
	function plgVmSetOnTablePluginParamsPayment ($name, $id, &$table) {

		return $this->setOnTablePluginParams ($name, $id, $table);
	}

	

	/**
	 * Create the table for this plugin if it does not yet exist.
	 *
	 * @author ValÃ©rie Isaksen
	 */
	public function getVmPluginCreateTableSQL () {
	
		return $this->createTableSQL ('Rivhit Payment Table');
	}
	
	/**
	 * Fields to create the payment table
	 *
	 * @return string SQL Fileds
	 */
	function getTableSQLFields () {

		$SQLfields = array(
			'id' => 'int(11) UNSIGNED NOT NULL AUTO_INCREMENT',
			'virtuemart_order_id' => 'int(1) UNSIGNED',
			'order_number' => 'char(64)',
			'virtuemart_paymentmethod_id' => 'mediumint(1) UNSIGNED',
			'payment_name' => 'varchar(5000)',
			'payment_order_total' => 'decimal(15,5) NOT NULL',
			'payment_currency' => 'smallint(1)',
			'email_currency' => 'smallint(1)',
			'cost_per_transaction' => 'decimal(10,2)',
			'cost_percent_total' => 'decimal(10,2)',
			'tax_id' => 'smallint(1)',
			
		);

		return $SQLfields;
	}

	/**
	 *
	 *
	 * @author Valérie Isaksen
	 */
	function plgVmConfirmedOrder ($cart, $order) {

		if (!($method = $this->getVmPluginMethod ($order['details']['BT']->virtuemart_paymentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement ($method->payment_element)) {
			return FALSE;
		}


		$session = JFactory::getSession();
		$return_context = $session->getId();
		$this->_debug = $method->debug;
		$this->logInfo('plgVmConfirmedOrder order number: ' . $order['details']['BT']->order_number, 'message');
		if (!class_exists('VirtueMartModelOrders')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
		}
		if (!class_exists('VirtueMartModelCurrency')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');
		}

		$address = ((isset($order['details']['ST'])) ? $order['details']['ST'] : $order['details']['BT']);
        
        $this->getPaymentCurrency($method);
		
		$currency_code_3 = shopFunctions::getCurrencyByID($method->payment_currency, 'currency_code_3');

		$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
		$totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, FALSE), 2);
		$cd = CurrencyDisplay::getInstance($cart->pricesCurrency);
		if ($totalInPaymentCurrency <= 0) {
			vmInfo('Payment amount is incorrect');
			return FALSE;
		}
		$groupToken = $this->_getGroupToken($method);
		if (empty($groupToken)) {
			vmInfo('You didnot enter grup token');
			return FALSE;
		}
$invoiceLanguage = $method->invoice_language;
//echo $invoiceLanguage;die;
$invoiceLanguageVal='';
		//get document language//
//print_r($order['details']['BT']);die();
   $shipCountId=$order['details']['BT']->virtuemart_country_id;
   $billCountId=$order['details']['ST']->virtuemart_country_id;   
    switch ($invoiceLanguage){
      case "hebrew":
        $invoiceLanguageVal="he";
        break;
      case "en":
        $invoiceLanguageVal="en";
        break;
      case "billing":
        if($billCountId=='104'){
          $invoiceLanguageVal="he";
        }else{$invoiceLanguageVal="en";}
        break;
      case "shipping":
        if($shipCountId=='104'){
          $invoiceLanguageVal="he";
        }else{$invoiceLanguageVal="en";}
        break;
      case "billingorshipping":
      if($shipCountId=='104'OR $billCountId=='104'){
        $invoiceLanguageVal="he";
      }else{$invoiceLanguageVal="en";}
      break;
      default:
        $invoiceLanguageVal="en";
      }
 $exemptVat = $method->exempt_vat;
 $exemptVatVal ='';    
   //get Exempt Vat value//
   switch ($exemptVat){
      case "chargevat":
        $exemptVatVal="false";
        break;
      case "exempt":
         $exemptVatVal="true";
        break;
      case "billing":
        if($billCountId=='104'){
          $exemptVatVal="false";
        }else{$exemptVatVal="true";}
        break;
      case "shipping":
        if($shipCountId=='104'){
          $exemptVatVal="false";
        }else{$exemptVatVal="true";}
        break;
      case "billingorshipping":
      if($shipCountId=='104'OR $billCountId=='104'){
        $exemptVatVal="false";
      }else{$exemptVatVal="true";}
      break;
      default:
        $exemptVatVal="true";
      }   
      if (!$method->redirct_url) {
      		$method->redirct_url = JURI::base().'index.php?option=com_virtuemart&view=vmplg&task=pluginresponsereceived';
      	}

		$ship_value = $cart->pricesUnformatted['shipmentValue'];
		foreach ($cart->products as $key => $product) {
			$items[]=array(
		    	  'Id'=>0,
		    	  'CatalogNumber' => $product->product_sku,
		          'Quantity' => $product->quantity,
		          'UnitPrice' => round($cart->pricesUnformatted[$key]['basePriceVariant'], 2),
		          'Description' => $product->product_name
    	 ); 

		}
		if($ship_value > 0){
			$items[]=array(
	           'Id' => 0,
	           'CatalogNumber' => '0',
	           'Quantity' => 1,
	           'UnitPrice' => $ship_value,
	           'Description' => strip_tags($cart->cartData['shipmentName'])
		   );
	   }
	   if($cart->pricesUnformatted['billTaxAmount'] > 0){
		   $items[]=array(
		           'Id' => 0,
		           'CatalogNumber' => '0',
		           'Quantity' => 1,
		           'UnitPrice' => $cart->pricesUnformatted['billTaxAmount'],
		           'Description' => 'מע"מ'
		   );
	   }
	   $data = array(
		       'GroupPrivateToken' =>$groupToken,
		       'RedirectURL'=>$method->redirct_url,
		       'IPNURL'=>$method->ipn_url,
		       'ExemptVAT'=>$exemptVatVal,
		       'MaxPayments'=>$method->max_payment,
		       'CreditFromPayment'=>$method->credit_from_payment,
		       'EmailAddress'=>$order['details']['BT']->email,
		       'CustomerLastName'=>$order['details']['BT']->last_name,
		       'CustomerFirstName' =>$order['details']['BT']->first_name,   
		       'Address'=>$order['details']['BT']->address_1,
		       'City'=>$order['details']['BT']->city,
		       'PhoneNumber'=>$order['details']['BT']->phone_1,
		       'FaxNumber'=>$order['details']['BT']->fax,
		       'Comments'=>$cart->cartfields['customer_note'],
		       //'CustomerId'=>12356,
		       'Order' => $order['details']['BT']->order_number,
		       'Custom1' => $cart->virtuemart_order_id,
		       'Custom2' => $return_context,
		       //'Currency' => $_order->getOrderCurrencyCode(),  
		       'HideItemList'=>$method->hide_itemlist,
		       'DocumentLanguage'=>$invoiceLanguageVal,
		       'CreateToken'=>$method->create_token,
		       'Discount'=>-($cart->pricesUnformatted['billDiscountAmount'] + $cart->pricesUnformatted['couponValue']),
	           'Items' => $items
     );
if(is_numeric($order['details']['BT']->zip)){
	  $data += array('Zipcode' =>$order['details']['BT']->zip,);
}
/*echo "<pre>";print_r($cart->pricesUnformatted);die();*/

		
			
			// Prepare data that should be stored in the database
			$dbValues['order_number'] = $order['details']['BT']->order_number;
			$dbValues['payment_name'] = $this->renderPluginName($method, $order);
			$dbValues['virtuemart_paymentmethod_id'] = $cart->virtuemart_paymentmethod_id;
			$dbValues['cost_per_transaction'] = $method->cost_per_transaction;
			$dbValues['cost_percent_total'] = $method->cost_percent_total;
			$dbValues['payment_currency'] = $method->payment_currency;
			$dbValues['email_currency'] = $email_currency;
			$dbValues['payment_order_total'] = $totalInPaymentCurrency;
			$dbValues['tax_id'] = $method->tax_id;
			$this->storePSPluginInternalData($dbValues);

			$url = $this->_getUrl($method);
    		//echo $url;die();
			$myUrl = $this->_getUrlToView($url, $data);

		$window_type = $method->window_type;
               	$iframe_width = $method->popup_width;
		$iframe_height = $method->popup_height;
		
			if($window_type == 'redirect'){
		$html = '<html><head><title>Redirection</title></head><body><div style="margin: auto; text-align: center;">';
		$html .= '<form action="' . $myUrl . '" method="post" name="vm_paypal_form"  accept-charset="UTF-8">';
		$html .= '<input type="submit"  value="אנא המתן.. מתחבר למערכת הסליקה iCredit" />';
		$html .= '<input type="hidden" name="charset" value="utf-8">';
		
		$html .= '</form>';
		$html .= ' <script type="text/javascript">';
		$html .= ' document.vm_paypal_form.submit();';
		$html .= ' </script></body></html>';
		}
		elseif($window_type == 'iframe'){
		$html = '<iframe onload="iFrameHeight()" id="blockrandom" name="iframe" src="'. $myUrl .'" width="'. $iframe_width .'" height="'. $iframe_height .'" frameborder="0" scrolling="yes"></iframe>';
		$html .= '<script>function iFrameHeight() {var h = 0;if (!document.all) {h = document.getElementById("blockrandom").contentDocument.height;	document.getElementById("blockrandom").style.height = h + 60 + "px";} else if (document.all) {h = document.frames("blockrandom").document.body.scrollHeight;document.all.blockrandom.style.height = h + 20 + "px";}}</script>';
		$html .= '<script src="plugins/vmpayment/rivhit/assets/jquery.cookie.js"></script>
			<script type="text/javascript">
      			jQuery(document).ready(function(){
				
				jQuery.cookie("redirect", "0", { expires: 1 });
      			});
      		</script>';
		}
		else{
	
		$html = '<div id="popup_val">';
		$html .= '<iframe onload="iFrameHeight()" id="blockrandom" name="iframe" src="'. $myUrl .'" width="'. $iframe_width .'" height="'. $iframe_height .'" frameborder="0" scrolling="yes"></iframe>';
		$html .= '</div>';
		$html .= '<script>function iFrameHeight() {var h = 0;if (!document.all) {h = document.getElementById("blockrandom").contentDocument.height;	document.getElementById("blockrandom").style.height = h + 60 + "px";} else if (document.all) {h = document.frames("blockrandom").document.body.scrollHeight;document.all.blockrandom.style.height = h + 20 + "px";}}</script>';
		$html .= '<script src="plugins/vmpayment/rivhit/assets/jquery.cookie.js"></script>
			<script type="text/javascript">
      			jQuery(document).ready(function(){
				
				jQuery.cookie("redirect", "0", { expires: 1 });
				var content = jQuery("#popup_val").html();
				jQuery("#popup_val").hide();
				jQuery.fancybox({
					"autoScale" : "true",
					"autoDimensions" : "true",
					"overlayShow" : "true",
					"scrolling" : "no",
					"content" : content,
					"onComplete" : function(){
						jQuery("#fancybox-wrap").css({"top":"30px", "bottom":"auto"});
						
						}
				});
      			});
      		</script>
		<script type="text/javascript" src="plugins/vmpayment/rivhit/assets/jquery.fancybox.js"></script>
	         <link rel="stylesheet" type="text/css" href="plugins/vmpayment/rivhit/assets/jquery.fancybox.css" media="screen" />';
		}
			$cart->_confirmDone = FALSE;
		$cart->_dataValidated = FALSE;
		$cart->setCartIntoSession();
		$cart->emptyCart();
		JRequest::setVar('html', $html);
	}
	/**
	 * @param $method
	 * @return mixed
	 */
	function _getUrlToView($url, $data) {

		    $content = json_encode($data); 
		    //echo $content;die();
			$curl = curl_init($url);
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
			curl_setopt($curl, CURLOPT_POSTFIELDS, $content);
			curl_setopt($curl, CURLOPT_HEADER, 0);
			curl_setopt($curl, CURLOPT_TIMEOUT, 45);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($curl, CURLOPT_POST, 1);
			curl_setopt($curl, CURLOPT_HTTPHEADER,array("Content-type: application/json"));


			 
			$result     = curl_exec($curl);
			//echo $result;die();
			$response   = json_decode($result);

			$url_to_view = $response->URL;

			curl_close($curl);
		    return $url_to_view;
	}
	/**
	 * @param $method
	 * @return mixed
	 */
	function _getGroupToken($method) {

		return $method->sandbox ? $method->sandbox_api_login_id : $method->api_login_id;
	}
	/**
	 * @param $method
	 * @return string
	 */
	function _getUrl($method) {

		$url = $method->sandbox ? 'https://testicredit.rivhit.co.il/API/PaymentPageRequest.svc/GetUrl' : 'https://icredit.rivhit.co.il/API/PaymentPageRequest.svc/GetUrl';

		return $url;
	}
	/**
	 * @param $method
	 * @return string
	 */
	function _getVerifyUrl($method) {

		$url = $method->sandbox ? 'https://testicredit.rivhit.co.il/API/PaymentPageRequest.svc/Verify' : 'https://icredit.rivhit.co.il/API/PaymentPageRequest.svc/Verify
';

		return $url;
	}
	/**
	 * @param $html
	 * @return bool|null|string
	 */
	function plgVmOnPaymentResponseReceived(&$html) {


		if (!class_exists('VirtueMartCart')) {
			require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
		}
		if (!class_exists('shopFunctionsF')) {
			require(JPATH_VM_SITE . DS . 'helpers' . DS . 'shopfunctionsf.php');
		}
		if (!class_exists('VirtueMartModelOrders')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
		}
$db = JFactory::getDbo();
$query = $db->getQuery(true);
$query->select('virtuemart_paymentmethod_id');
$query->from($db->quoteName('#__virtuemart_orders'));
$query->order($db->quoteName('virtuemart_order_id') . ' DESC');
$db->setQuery($query);
$result = $db->loadResult();

$method = $this->getVmPluginMethod ($result);
$window_type = $method->window_type;
if($window_type == 'popup' || $window_type == 'iframe'){
 if (!$method->redirct_url) {
      		$method->redirct_url = JURI::base().'index.php?option=com_virtuemart&view=vmplg&task=pluginresponsereceived';
      		
		$html = '<script src="plugins/vmpayment/rivhit/assets/jquery.cookie.js"></script>
			<script type="text/javascript">
      			jQuery(document).ready(function(){
      				
				if(jQuery.cookie("redirect") == 1){
      				window.top.location.href = "'. $method->redirct_url.'";
				}
				jQuery.cookie("redirect", "0", { expires: 1 });
      			});
      		</script>';
      		
      	}
      	else{
      		$html = '<script src="plugins/vmpayment/rivhit/assets/jquery.cookie.js"></script>
			<script type="text/javascript">
      			jQuery(document).ready(function(){
      				
				if(jQuery.cookie("redirect") == 1){
      				window.top.location.href = "'. $method->redirct_url.'";
				}
				jQuery.cookie("redirect", "0", { expires: 1 });
      			});
      		</script>';
      		
      	}
}

		//vmdebug('PAYPAL plgVmOnPaymentResponseReceived', $paypal_data);
		// the payment itself should send the parameter needed.
		//$virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);
		//$order_number = JRequest::getString('on', 0);
		

		/*if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return NULL;
		}

		if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number))) {
			return NULL;
		}
		if (!($paymentTable = $this->getDataByOrderId($virtuemart_order_id))) {
			// JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
		$payment_name = $this->renderPluginName($method);
		$html = $this->_getPaymentResponseHtml($paymentTable, $payment_name);

		//We delete the old stuff
		// get the correct cart / session
		$cart = VirtueMartCart::getCart();
		$cart->emptyCart();*/
		return TRUE;
	}
	/** IPN Processing
	 * @return bool|null
	 */
	function plgVmOnPaymentNotification() {

		//$this->_debug = true;
		if (!class_exists('VirtueMartModelOrders')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
		}
		/*$modelOrder = VmModel::getModel('orders');
		$order = array();
		$order['customer_notified'] = 1;
		$order['order_status'] = $method->status_success;
		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);

*/





		$this->_debug = $method->debug;
		
		//$rivhit_data = JRequest::get('post');
		$raw_post_data = file_get_contents('php://input');
        $raw_post_array = explode('&', $raw_post_data);
        $IPNPost = array();
        foreach ($raw_post_array as $keyval){
        $keyval = explode ('=', $keyval);
	        if (count($keyval) == 2){
	            $IPNPost[$keyval[0]] = urldecode($keyval[1]);
	        }
    	}      
    $virtuemart_order_id = $IPNPost['Custom1'];
		if (!($payments = $this->getDatasByOrderId($virtuemart_order_id))) {
					return FALSE;
				}

		$method = $this->getVmPluginMethod($payments[0]->virtuemart_paymentmethod_id);
    
           $orderId = $IPNPost['Order'];
           $groupToken = $this->_getGroupToken($method);
           $postData = array('GroupPrivateToken' => $groupToken,
                         'SaleId'=> $IPNPost['SaleId'],
                         'TotalAmount'=> $IPNPost['TransactionAmount']
                        ); 


    
             
            $url = $this->_getVerifyUrl($method);
		    $jsonData = json_encode($postData); 
			$curl = curl_init($url);
			curl_setopt($curl, CURLOPT_HEADER, false);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($curl, CURLOPT_HTTPHEADER,array("Content-type: application/json"));
			curl_setopt($curl, CURLOPT_POST, true);
			curl_setopt($curl, CURLOPT_POSTFIELDS, $jsonData);
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
			$result     = curl_exec($curl);
			$response   = json_decode($result);
			$Status = $response->Status;
			curl_close($curl);
			$modelOrder = VmModel::getModel('orders');
		    $order = array();
       // print_r($raw_post_array);die();
			if ($Status == 'VERIFIED'){
			       	$order['order_status'] = $method->status_success;
			        $order['comments'] = JText::sprintf('The payment for order %s is Confirmed', $orderId);
			   }else{
			   		$order['order_status'] = $method->status_pending;
			   	    $order['comments'] = JText::sprintf('The payment for order %s is pending', $orderId) ;
				}


		$this->logInfo('plgVmOnPaymentNotification return new_status:' . $order['order_status'], 'message');
		
		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
		//// remove vmcart
		/*if (isset($IPNPost['Custom2'])) {
			$this->emptyCart($IPNPost['Custom2'], $orderId);
		}*/

	}

	

	/**
	 * Display stored payment data for an order
	 *
	 */
	function plgVmOnShowOrderBEPayment ($virtuemart_order_id, $virtuemart_payment_id) {

		if (!$this->selectedThisByMethodId ($virtuemart_payment_id)) {
			return NULL; // Another method was selected, do nothing
		}

		if (!($paymentTable = $this->getDataByOrderId ($virtuemart_order_id))) {
			return NULL;
		}

		$html = '<table class="adminlist">' . "\n";
		$html .= $this->getHtmlHeaderBE ();
		$html .= $this->getHtmlRowBE ('STANDARD_PAYMENT_NAME', $paymentTable->payment_name);
		$html .= $this->getHtmlRowBE ('STANDARD_PAYMENT_TOTAL_CURRENCY', $paymentTable->payment_order_total . ' ' . $paymentTable->payment_currency);
		$html .= '</table>' . "\n";
		return $html;
	}

	function getCosts (VirtueMartCart $cart, $method, $cart_prices) {

		if (preg_match ('/%$/', $method->cost_percent_total)) {
			$cost_percent_total = substr ($method->cost_percent_total, 0, -1);
		} else {
			$cost_percent_total = $method->cost_percent_total;
		}
		return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
	}

	/**
	 * Check if the payment conditions are fulfilled for this payment method
	 *
	 * @author: Valerie Isaksen
	 *
	 * @param $cart_prices: cart prices
	 * @param $payment
	 * @return true: if the conditions are fulfilled, false otherwise
	 *
	 */
	protected function checkConditions ($cart, $method, $cart_prices) {

		$this->convert ($method);
		// 		$params = new JParameter($payment->payment_params);
		$address = (($cart->ST == 0) ? $cart->BT : $cart->ST);

		// We come from the calculator, the $cart->pricesUnformatted does not exist yet
		//$amount = $cart->pricesUnformatted['billTotal'];
		$amount = $cart_prices['salesPrice'];

		$amount_cond = ($amount >= $method->min_amount AND $amount <= $method->max_amount
			OR
			($method->min_amount <= $amount AND ($method->max_amount == 0)));
		if (!$amount_cond) {
			return FALSE;
		}
		$countries = array();
		if (!empty($method->countries)) {
			if (!is_array ($method->countries)) {
				$countries[0] = $method->countries;
			} else {
				$countries = $method->countries;
			}
		}

		// probably did not gave his BT:ST address
		if (!is_array ($address)) {
			$address = array();
			$address['virtuemart_country_id'] = 0;
		}

		if (!isset($address['virtuemart_country_id'])) {
			$address['virtuemart_country_id'] = 0;
		}
		if (count ($countries) == 0 || in_array ($address['virtuemart_country_id'], $countries) ) {
			return TRUE;
		}

		return FALSE;
	}

	function convert ($method) {

		$method->min_amount = (float)$method->min_amount;
		$method->max_amount = (float)$method->max_amount;
	}

	/*
* We must reimplement this triggers for joomla 1.7
*/

	/**
	 * Create the table for this plugin if it does not yet exist.
	 * This functions checks if the called plugin is active one.
	 * When yes it is calling the standard method to create the tables
	 *
	 * @author Valérie Isaksen
	 *
	 */
	function plgVmOnStoreInstallPaymentPluginTable ($jplugin_id) {

		return $this->onStoreInstallPluginTable ($jplugin_id);
	}

	/**
	 * This event is fired after the payment method has been selected. It can be used to store
	 * additional payment info in the cart.
	 *
	 * @author Max Milbers
	 * @author Valérie isaksen
	 *
	 * @param VirtueMartCart $cart: the actual cart
	 * @return null if the payment was not selected, true if the data is valid, error message if the data is not vlaid
	 *
	 */
	public function plgVmOnSelectCheckPayment (VirtueMartCart $cart, &$msg) {

		return $this->OnSelectCheck ($cart);
	}

	/**
	 * plgVmDisplayListFEPayment
	 * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for exampel
	 *
	 * @param object  $cart Cart object
	 * @param integer $selected ID of the method selected
	 * @return boolean True on succes, false on failures, null when this plugin was not selected.
	 * On errors, JError::raiseWarning (or JError::raiseError) must be used to set a message.
	 *
	 * @author Valerie Isaksen
	 * @author Max Milbers
	 */
	public function plgVmDisplayListFEPayment (VirtueMartCart $cart, $selected = 0, &$htmlIn) {

		return $this->displayListFE ($cart, $selected, $htmlIn);
	}

	/*
* plgVmonSelectedCalculatePricePayment
* Calculate the price (value, tax_id) of the selected method
* It is called by the calculator
* This function does NOT to be reimplemented. If not reimplemented, then the default values from this function are taken.
* @author Valerie Isaksen
* @cart: VirtueMartCart the current cart
* @cart_prices: array the new cart prices
* @return null if the method was not selected, false if the shiiping rate is not valid any more, true otherwise
*
*
*/

	public function plgVmonSelectedCalculatePricePayment (VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {

		return $this->onSelectedCalculatePrice ($cart, $cart_prices, $cart_prices_name);
	}

	function plgVmgetPaymentCurrency ($virtuemart_paymentmethod_id, &$paymentCurrencyId) {

		if (!($method = $this->getVmPluginMethod ($virtuemart_paymentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement ($method->payment_element)) {
			return FALSE;
		}
		$this->getPaymentCurrency ($method);

		$paymentCurrencyId = $method->payment_currency;
		return;
	}

	/**
	 * plgVmOnCheckAutomaticSelectedPayment
	 * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
	 * The plugin must check first if it is the correct type
	 *
	 * @author Valerie Isaksen
	 * @param VirtueMartCart cart: the cart object
	 * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
	 *
	 */
	function plgVmOnCheckAutomaticSelectedPayment (VirtueMartCart $cart, array $cart_prices = array(), &$paymentCounter) {

		return $this->onCheckAutomaticSelected ($cart, $cart_prices, $paymentCounter);
	}

	/**
	 * This method is fired when showing the order details in the frontend.
	 * It displays the method-specific data.
	 *
	 * @param integer $order_id The order ID
	 * @return mixed Null for methods that aren't active, text (HTML) otherwise
	 * @author Max Milbers
	 * @author Valerie Isaksen
	 */
	public function plgVmOnShowOrderFEPayment ($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {

		$this->onShowOrderFE ($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
	}
/**
	 * @param $orderDetails
	 * @param $data
	 * @return null
	 */

	function plgVmOnUserInvoice ($orderDetails, &$data) {

		if (!($method = $this->getVmPluginMethod ($orderDetails['virtuemart_paymentmethod_id']))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement ($method->payment_element)) {
			return NULL;
		}
		//vmdebug('plgVmOnUserInvoice',$orderDetails, $method);

		if (!isset($method->send_invoice_on_order_null) or $method->send_invoice_on_order_null==1 or $orderDetails['order_total'] > 0.00){
			return NULL;
		}

		if ($orderDetails['order_salesPrice']==0.00) {
			$data['invoice_number'] = 'reservedByPayment_' . $orderDetails['order_number']; // Nerver send the invoice via email
		}

	}
	
}
//no close php tag
